package org.jeecg.modules.stm.survey.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
 
 
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
import org.jeecg.modules.stm.survey.entity.SurveyTpl;
import org.jeecg.modules.stm.survey.service.ISurveyTplService;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import java.util.Arrays;
import java.util.List;

 /**
 * @Description: 调查问卷模板
 * @Author: jeecg-boot
 * @Date:   2023-11-13
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/survey/surveyTpl")
@Slf4j
public class SurveyTplController extends JeecgController<SurveyTpl, ISurveyTplService> {
	@Autowired
	private ISurveyTplService surveyTplService;
	
	/**
	 * 分页列表查询
	 *
	 * @param surveyTpl
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "调查问卷模板-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<SurveyTpl>> queryPageList(SurveyTpl surveyTpl,
												  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
												  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
												  HttpServletRequest req) {
		QueryWrapper<SurveyTpl> queryWrapper = QueryGenerator.initQueryWrapper(surveyTpl, req.getParameterMap());
		Page<SurveyTpl> page = new Page<SurveyTpl>(pageNo, pageSize);
		IPage<SurveyTpl> pageList = surveyTplService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	   
	 @GetMapping(value = "/queryAllList" +
			 "")
	 public Result<List<SurveyTpl>> queryAllList(SurveyTpl surveyTpl,
												   HttpServletRequest req) {
		 QueryWrapper<SurveyTpl> queryWrapper = new QueryWrapper<>();
		 
		 List<SurveyTpl> list = surveyTplService.list(queryWrapper);
		 return Result.OK(list);
	 }
	
	/**
	 *   添加
	 *
	 * @param surveyTpl
	 * @return
	 */
	@AutoLog(value = "调查问卷模板-添加")
	  
	@RequiresPermissions("survey:survey_tpl:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody SurveyTpl surveyTpl) {
		if(surveyTpl.getCode()==null) {
			//surveyTpl.setCode(surveyTplService.getSurveyTplCode());
		}
		surveyTplService.save(surveyTpl);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param surveyTpl
	 * @return
	 */
	@AutoLog(value = "调查问卷模板-编辑")
	  
	@RequiresPermissions("survey:survey_tpl:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody SurveyTpl surveyTpl) {
		surveyTplService.updateById(surveyTpl);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "调查问卷模板-通过id删除")
	  
	@RequiresPermissions("survey:survey_tpl:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		surveyTplService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "调查问卷模板-批量删除")
	  
	@RequiresPermissions("survey:survey_tpl:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.surveyTplService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "调查问卷模板-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<SurveyTpl> queryById(@RequestParam(name="id",required=true) String id) {
		SurveyTpl surveyTpl = surveyTplService.getById(id);
		if(surveyTpl==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(surveyTpl);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param surveyTpl
    */
    @RequiresPermissions("survey:survey_tpl:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, SurveyTpl surveyTpl) {
        return super.exportXls(request, surveyTpl, SurveyTpl.class, "调查问卷模板");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("survey:survey_tpl:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, SurveyTpl.class);
    }

}
